module Functions.Pandoc
  ( runPandoc
  ) where

import Types (IsFunction(..), Token)
import DependencyGenerator (DepGenM, TokenableTo(..), runFunction)

import Data.Text (Text)
import qualified Data.Text.Lazy as TL
import qualified Text.Pandoc as P
import qualified Text.Blaze.Html.Renderer.Text as B


data RunPandoc = RunPandoc deriving Show
instance IsFunction RunPandoc Text Text where
  evalFunction RunPandoc contents =
    let settings = P.def { P.readerExtensions = P.extensionsFromList [ P.Ext_raw_html ] }
        m = P.writeHtml5 P.def =<< P.readMarkdown settings contents
    in case P.runPure m of
         Left e -> error ("unexpected pandoc error: " ++ show e)
         Right html -> TL.toStrict $ B.renderHtml html

runPandoc :: TokenableTo Text a => a -> DepGenM (Token Text)
runPandoc a = runFunction RunPandoc =<< toToken a
