{-# LANGUAGE GADTs #-}
module Types.Token
  ( Token(..)
  ) where

data Token a where
  Token :: Int -> Token a
  TupleToken :: Token a -> Token b -> Token (a, b)
  ZipToken :: Token [a] -> Token [b] -> Token [(a, b)]
  ListToken :: [Token a] -> Token [a]
  NoToken :: Token ()

deriving instance Show (Token a)
